{
        CDDB Component by Ari Sundholm, Nanojiffy 2001-2002
        This component is open-source freeware. I do not ensure the quality
        of this component. This component is meant to be cross-platform. The
        HTTP features have not yet been implemented for Kylix and are switched
        off if compiled with Kylix. The test program's HTTP features don't work
        either while in Linux environment.
        If you find a bug or have any suggestions, feel free to mail me
        at <megari@mbnet.fi>.

        Thanks to: Luc Vigato for some functions from his DiscIDCalc program.
                   Andy Key whose sources I used for SPTI support.
                   Franois Piette for creating ICS. (http://www.overbyte.be)
                   Jess Pallars Quintero for bugfixes and additions.
                   Frank for proxy support, many additions and fixes.
                   Yursoft for fixes in ParseCurrentEntry.

        Version 0.1.70 Release
        - Added property LocalCDDBDLLPath in order to separate the DLL path and
          the path of the Local CD Database so you can have them in separate
          directories
        - Fixed a range check error in CalcDiscID(): changed used variables to be
          of type Cardinal instead of Integer.
        - Added HTTP Proxy support and added some missing assignment tests.
          Thanks to Frank.
        - Frank also fixed some minor bugs and suggested a minor behavior change
          to ParseQuery which I accepted.
        - Frank also added a new state for the component, CS_SITESFAIL.
        - Frank also rethought ParseSites.
        - There were two bugs in ParseCurrentEntry: Additional/Extended track
          info was not filled in properly into FCDInfo and the procedure needed
          range checking to be off in order not to generate errors. Fixed now.
        - Added missing parsing of Revision into ParseCurrentEntry. Thanks to
          Yursoft.
        - Artist / Title parsing in ParseCurrentEntry made more error-tolerant
          by Yursoft.
        - Defining INTERNAL-PARSER no longer disables LocalCDDB.dll.
        - INTERNAL-PARSER now enabled as default.
        - Moved Frank's proxy server properties into the published section.
        - Now the amount of lines allocated for FCurrentEntry is in a constant.
        - Added SMTP submission. To use it call smtp_submit().
        - Fixed a bug in FormEntry(): FCurrentEntry wasn't emptied before
          filling the new data which caused extra lines to exist after the
          PLAYLIST= line, which should be the last one.
        - Added submission via SMTP. It can be used by calling smtp_submit().
        - Frank further improved the internal entry parser.
        - I added backslash(fake escaped characters) detection and fix.
        - I added ZeroMemory( @FCDInfo, SizeOf( FCDInfo ) ); in the beginning of
          ParseCurrentEntry in order to avoid previous and current data being
          glued together.
        - Fixed support for BCB and Delphi versions prior to Delphi 6.
        - Fixed 'the icon bug' which caused the icon of the host app to become
          the cddbcomp icon.
        - Reverted a change from Frank since it caused the component to
          malfunction. The ZeroMemory addition above is a replacement for it.
        - Fixed a bug which occurred with BCB only: http_submit caused an access
          violation.
        - Added the procedure FormCurrentEntry for those not using LocalCDDB.dll.
        - Commented a line offending with the protocol level from Frank's new
          ParseSites. Developers! Always remember to call Proto when using CDDBP.
        - Fixed some bugs in SptiReadToc. Thanks to Frank for most of them!

        Version 0.1.65 Release
        - In a nutshell: a major BCB compatibility update.
        - Fixed conditional defines in cddb.pas. Now INTERNAL-PARSER works.
        - Conditional defines changed: now you can use TWSocket easily instead
          of TICSSocket by defining USE-WSOCKET
        - Fixed a lot of bugs in the internal parser, ParseCurrentEntry. Luckily
          it is not used unless specified. Now it works well.
        - In TCddb.Create changed FNoteToUser to be: 'Submitted using Ari''s
          freedb component 0.1.65. Bugs? megari@mbnet.fi'.
        - Now LocalCDDB.pas is in the uses clause only if LINUX isn't defined.
        - Improved HTTP functions to be more verbose.
        - Improved HTTP functions to use common memory streams.
        - Improved all HTTP functions http_query, http_read, http_sites and
          http_submit to be asynchronous.
        - Reduced file size by removing commented useless blocks of code.
        - Changed text 'ASPI not installed!' to 'No CD-ROM interface detected!'
        - Fixed a small cosmetic bug in Parse()
        - Improved BCB compatibility: BCB didn't like ShortString. Now changed
          to string.
        - Made some conditional defines for BCB compatibility which alter the
          declarations and implementations of some functions to fit BCB's taste.
          Some of the changed code for BCB had to be made a little dirty, since
          BCB generated errors when using genuine pointers instead of integers.
        - OnMatchEvent changed to use a typed array, TMatchArray for BCB
          compatibility.
        - Added a BCB test program.

        Version 0.1.60 Release (From now on: Release if released, Development if in development)
        - A major upgrade with important bugfixes!
        - Bugfixed an issue about being logged in as an user instead of
          Administrator.
        - Now detected whether a disc is in the drive works with SPTI and
          IOCTL_CDROM.
        - Now the drive description is retrieved in NT/2000/XP via SPTI
        - Type TCdInfo has a new member, DriveLetter : Char;
        - Optimized and generalized drive handling a bit.
        - Removed a bug: because of typing <= instead of > the first TOC
          initialization was never done.
        - Definition TEST-SUBMISSIONS has been removed. It has been replaced
          with a property, TCddb.SubmissionType.
        - Function http_submit now displays different statusmessages for "real"
          and test submissions.
        - Improved LocalCDDB.pas a bit. Now dynamic allocation on PChars is
          used in many occasions AND if LocalCDDB.dll is missing or invalid, an
          exception is raised. A new function: FindMatches. Updated the version
          number which is automatically filled in in TLocalCDDB.Create
        - LocalCDDB.dll has many more bugfixes now, one of which is critical for
          GraceNote(former CDDB.com) support.
        - LocalCDDB.dll has a new function: FindMatches. This functionality has
          been added to the component and test program.
        - All functions using LocalCDDB.dll now react to the situation no proper
          LocalCDDB.dll is found.
        - The VCL test program now includes an example how to make a query-read
          batch. This has been a problem. The solution is to use a custom
          message. Watch it and learn. The solution in the CLX test program is
          not as elegant. Both programs updated.

        Version 0.1.50
        - A major improvement! SPTI is now supported as well as IOCTL_CDROM
          which means that you can now use the component in Windows NT, 2000 &
          XP with no problems!
        - Because of SPTI support had to rewrite and/or change various things.
          Impact on app-developers very low. The new member in TCdRom record
          Description should now be used instead of combining Vendor, ProductId
          and Revision if program used in WinNT-based systems.
        - Test programs updated according to the SPTI update
        - Package problem experienced by many people fixed; actually in version
          0.1.47

        Version 0.1.47
        - Fixed some bugs in LocalCDDB.pas and LocalCDDB.dll. The bug in
          LocalCDDB wrapper caused input from the DLL to become corrupt if
          more than 2 entries in a row are read from the (local) database.
        - LocalCDDB.pas had problems with very long entry lines - fixed now.
        - Added new property to LocalCDDB wrapper: DBType - unfortunately only
          UNIX is supported by the DLL.
        - Finally updated the CLX test program.
        - Property InternalAspi enabled again.

        Version 0.1.46
        - Improved the wrapper, made bugfixes to LocalCDDB.dll. Improved by
          implementing the rest of the functions of the DLL. To use them call
          SaveInfoToLocalCDDB and ReadInfoFromLocalCDDB.
        - Only VCL test program updated to use the functions above, because I'm
          a bit busy.

        Version 0.1.45
        - Made a wrapper class around LocalCDDB.dll and implemented some of its
          functions, to use them call ParseEntry, FormEntry.
        - The internal parser is done. It can be used by calling
          ParseCurrentEntry.
        - Replaced FTempDiscid with FCDInfo.DiscID
        - Fixed some array property issues and therefore BCB is now supported.
        - Changed public property CDInfo to be of type PCDInfo to get it to work
          as expected from the user of the component's point of view. It can now
          be used like this CDDB.CDInfo.Tracks[0] := 'Voulez-Vous'; or
          CDDB.CDInfo := @MyCDInfo;

        Version 0.1.40
        - Made a fix to ParseQuery. Now it always parses the response somehow.
        - Added another help function of Franois Piette: IsDigit
        - A minor addition to TCddb.Create: now FServerAdditionalAddr is preset
          to '/~cddb/cddb.cgi'.
        - Resized TEntryArray to be an array[0..511] of string because of the
          fact that 256 lines wouldn't be enough at all. Updated test programs
          accordingly.
        - Started work with an internal entry parser. It is not finished yet
          and should not be used. I am going to make the component support
          a DLL by me and my best friend which will not only implement a great
          entry parser but also support local CDDB databases, so the internal
          parser's future is only up to those who want to make it better. I do
          not use it in my own programs.

        Version 0.1.39
        - Access violation encountered with the test program(s) has been solved.
          After all, it turned out to be a bug in my code. The fix was to make
          the destructor to execute inherited Destroy, which I had forgotten.
          This was first noticed in version 0.1.30pre2.
        - GetActiveDrive written in assembler. Not a big optimization. =)
        - Database entry handling would be really nice. Anybody willing to
          assist me? TCDInfo is still almost untouched...

        Version 0.1.38
        - Fixed a bug in ChangeActiveDrive: the return value of ReadCDToc was
          handled totally wrong. Thanks to Jess Pallars Quintero.
        - Added functions GetActiveDrive and GetActiveDriveLetter
        - Updated ReadCDToc a bit. Now it recognizes audio tracks more reliably.
        - An overloaded version of ChangeActiveDrive created in order to change
          the active drive utilizing the drive's letter. Works only in Win9x.

        Version 0.1.37
        - Fixed a bug in ParseSites: Description wasn't fully copied to server
          list because of a parsing bug. Thanks for the bugfix to Jess Pallars
          Quintero. A big hand to him!

        Version 0.1.36
        - Fixed Kylix compatibility; TOC retrieval broke it. CLX test program
          fixed, too.

        Version 0.1.35
        - Implemented TOC retrieval and updated test programs to support this.
          The functions are quite transparent to the developer.
        - Removed function PosP, since it's not used anymore. Encode does the
          job.

        Version 0.1.30
        - HTTP Submit finished. Added X-Cddb-Note and for it property NoteToUser.
          Test submissions can be triggered to real ones by undefining the
          definition TEST-SUBMISSIONS
        - HTTP Sites implemented, decided not to implement Lscat for now, since
          categories are fixed and if they change, the new categories probably
          wouldn't work all right with the old ones. A new version of software
          would have to be released anyway.
        - Removed some odd behavior when not logged in or not connected and
          trying to perform commands.
        - Because of freedb team's demand, I have now implemented Quit.
        - Should make some kind of an improvement to the component in order to
          ease development with it: the program using the component should get
          easily the information whether the response was OK or not. I'll try
          to come up with something.
        - Removed the unneeded blocking from TCddb.Connect. It was completely
          unnecessary. Now Connect returns immediately, as in event driven
          programming should be done.

        Version 0.1.30pre2
        - Fixed Kylix compatibility; now the component and the CLX test program
          compile on Kylix. In Connect, I couldn't find a replacement for
          getTickCount(); - the block created this way may be unnecessary
          anyway.
        - More testing done: no additional problems found. The VCL test program
          causes access violations after closing the project, but no problems in
          run-time occur. It's strange. This doesn't happen with the CLX version.
        - Fixed a cosmetical bug: OnStatusMessage( Self, 'OK, receiving matches' );
          isn't called anymore many times when receiving multiple matches.
        - Changed a little erroneous status message to the exactly right one.
          ('Protocol version' changed to 'Protocol level')
        - As function Encode does exactly what Space2Plus and even more,
          Space2Plus has been removed. A little optimization.

        Version 0.1.30pre1
        - HTTP Submit implemented. There has to be made more work and
          beta-testing before it can be marked as done in the To-Do list. For
          example, there is no parser for submit responses yet. Coming soon.
          All submitting is done in test mode for now.
        - Changed the structures(for example TCDInfo) a bit. All PChars have
          been changed to strings. This because PChars caused a lot of problems.
          Because of this change the component SHOULD be working more reliably.
          But, it may have generated some unforeseen problems.
        - Fixed a nasty bug with FTempDiscID: if Query returns an exact match,
          nothing is put into FTempDiscID for Read.
        - A small fix: no Windows.pas with Kylix!

        Version 0.1.26
        - HTTP Read has been implemented and it works.
        - Noticed a non-fatal bug: When receiving multiple matches, the
          OnStatusMessage( Self, 'OK, receiving matches' ); event will be fired
          many times. A cosmetical flaw.

        Version 0.1.25
        - Small fixes, there's now a destructor.
        - Improved HTTP Query. It works now! Code is messy, though. Next HTTP
          command to be implemented is HTTP Read.

        Version 0.1.24:
        - _Experimental_ HTTP Query support, therefore HTTP Support not removed
          from To-Do List
        - No more Debug infos to remove. You can use the component without
          removing them now.

        Version 0.1.12:
        - Initial version
        - Protocol level 5 supported
        - Hello, Proto, Sites, Query, Read implemented. Parsing of Read is not implemented.
        - Only CDDBP supported as of yet. HTTP support coming.
        - No submitting as of yet. Coming.
        - No documentation. Could somebody assist me with it?
        - Lots of bugs and not as programmer-friendly as could be. Report me!
        - NOTE!!! In functions Query and Read there are some hard-coded values
          for a command for debug purposes. To use the component properly remove
          or comment out the hard-coded values!!!
}

unit Cddb;
{$DEFINE INTERNAL-PARSER} //Change to {$DEFINE INTERNAL-PARSER} to enable internal entry parser.
{$IFNDEF LINUX}
{.$DEFINE BCB}//Define this if you have trouble with the conditional defines below.
{$DEFINE HTTP-SUPPORT}
{.$DEFINE USE-WSOCKET}//Change to {$DEFINE USE-WSOCKET} to use TWSocket instead of TICSSocket.
{$ENDIF}

{ VER80  => Delphi 1 }
{ VER90  => Delphi 2 }
{ VER93  => Bcb 1    }
{ VER100 => Delphi 3 }
{ VER110 => Bcb 3    }
{ VER120 => Delphi 4 }
{ VER125 => Bcb 4    }
{ VER130 => Delphi 5 }
{ VER140 => Delphi 6 }
{$IFNDEF VER80}
{$IFNDEF VER90}
{$IFNDEF VER100}
{$IFNDEF VER120}
{$IFNDEF VER130}
{$IFNDEF VER140}
{$IFNDEF LINUX} //I think Kylix likes the same code as Delphi
{$DEFINE BCB}
{$ENDIF}
{$ENDIF}
{$ENDIF}
{$ENDIF}
{$ENDIF}
{$ENDIF}
{$ENDIF}

{$IFDEF BCB}
{$OBJEXPORTALL On}
{$DEFINE USE-WSOCKET}
{$ENDIF}

interface

uses
{$IFNDEF LINUX}
  Windows,
  AspiCD,
{$ENDIF}
  SysUtils,
  Classes,
{$IFDEF HTTP-SUPPORT}
  HttpProt,
{$ENDIF}
  SmtpProt,
{$IFNDEF USE-WSOCKET}
  IcsSocket //NOTE: Only IcsSocket v.1 will do
{$ELSE}
  WSocket
{$ENDIF};

const
  EntryArrayLength = 512;

type

{$IFDEF LINUX}
  BOOL = LongBool;
  DWORD = LongWord;
{$ENDIF}

  TSubmissionType = ( TEST, SUBMIT );

  TLocation = record
    Latitude : string;
    Longitude : string;
    Description : string;
  end;

  TServerType = ( CDDBP
{$IFDEF HTTP-SUPPORT}
    , HTTP
{$ENDIF}
    );

  TServer = record
    Address : string;
    AdditionalAddress : string;
    ServerType : TServerType;
    // ProtocolLevel : string;
    Port : Integer;
    Location : TLocation;
  end;

{$IFDEF BCB}
  PServer = ^TServer;
{$ENDIF}

  TServerArray = array[0..99] of TServer;

  TParseResult = ( SyntaxError, CantPerform, InformativeMessage, OKSoFar, OK,
    ConnectionCloses,
    MoreInputCtoS, MoreInputStoC, Ready );
  TParseResults = set of TParseResult;

  TMatchArray = array[0..99] of string;

  TStatusEvent = procedure( Sender : TObject; Status : string ) of object;
  TMatchEvent = procedure( Sender : TObject; Matches : TMatchArray; var
    RightOne : integer ) of object;

{$IFDEF LINUX}
  //  Defined in AspiCD.pas

  TTOC = record
    M : Byte;
    S : Byte;
    F : Byte;
    AudioTrack : BOOL; // indicates if the track is an audio or data track
  end;

  TCdToc = record
    TracksOnCD : Byte;
    LeadOut : TTOC;
    Tracks : array[0..99] of TTOC;
  end;
{$ENDIF}

  PCdToc = ^TCdToc;
  TStringArray = array[0..99] of string;
  TEntryArray = array[0..EntryArrayLength - 1] of string;

  TMatch = record
    Category : string;
    DiscID : string;
  end;

  TMatches = array[0..99] of TMatch;

  TCDInfo = record
    DiscID : string;
    Artist : string;
    Title : string;
    Year : string;
    Genre : string;
    AddAlbumInfo : string;
    Tracks : TStringArray;
    AddTrkInfo : TStringArray;
    Category : string;
    Revision : Integer;
    CDToc : TCDToc;
  end;
  PCDInfo = ^TCDInfo;

  TCddb = class( TComponent )
  private
    { Private declarations }
    FCDDBSocket : {$IFNDEF USE-WSOCKET}TICSSocket{$ELSE}TWSocket{$ENDIF};
    FSmtpCli : TSmtpCli;
{$IFDEF HTTP-SUPPORT}
    FHTTPCli : THTTPCli;
    FStreamIn : TMemoryStream;
    FStreamOut : TMemoryStream;
    procedure ParseSubmit( Line : string );

    { FVC }
    procedure http_SetProxyAddress( const TheAddress : string );
    procedure http_SetProxyPort( const ThePort : string );
    function http_GetProxyAddress : string;
    function http_GetProxyPort : string;
    { end FVC }
{$ENDIF}
    procedure SetNoteToUser( Note : string );
    function Parse( Line : string ) : TParseResults;
    function ParseSignOnBanner( Line : string ) : TParseResults;
    function ParseHello( Line : string ) : TParseResults;
    function ParseSites( Line : string ) : TParseResults;
    function ParseProto( Line : string ) : TParseResults;
    function ParseQuery( Line : string ) : TParseResults;
    function ParseRead( Line : string ) : TParseResults;

    function GetEntryLine( Index : integer ) : string;
    procedure SetEntryLine( Index : integer; Line : string );
    function GetServerByIndex( Index : integer ) :
{$IFNDEF BCB}TServer{$ELSE}PServer{$ENDIF};
    procedure SetServerByIndex( Index : integer; Server :
{$IFNDEF BCB}TServer{$ELSE}PServer{$ENDIF} );
    function GetCDInfo : PCDInfo;
    procedure SetCDInfo( Info : PCDInfo );

  protected
    { Protected declarations }
{$IFNDEF LINUX}
    FInternalTOCRetrieve : Boolean;
    FCDRoms : TCDRoms;
{$ENDIF}
    FLocalCDDBPath : string;
    FLocalCDDBDLLPath : string;
    FNoteToUser : string;
    FOnStatusMessage : TStatusEvent;
    FOnDataExchange : TStatusEvent;
    FOnMatch : TMatchEvent;
    FLoggedIn : Boolean;
    FCDInfo : TCDInfo;
    FMatches : TMatchArray;
    FCurrentEntry : TEntryArray;
    FState : integer;
    FUserEmailAddr : string;
    FSubmitEmailAddr : string;
    FSubmissionType : TSubmissionType;
    FServerAddr : string;
    FServerAdditionalAddr : string;
    FServerPort : string;
    FServerLatitude : string;
    FServerLongitude : string;
    FServerDescription : string;
    FServerType : TServerType;
    FMailServerAddr : string;
    FMailServerPort : string;
    FClientName : string;
    FClientVersion : string;
    FClientComments : string;
    FServer : TServer;
    FServers : TServerArray;
  public
    { Public declarations }
    constructor Create( AOwner : TComponent ); override;
    destructor Destroy; override;
    { Functions and procedures }
    function smtp_submit : Integer;
{$IFDEF HTTP-SUPPORT}
    function http_query : Integer;
    function http_read : Integer;
    function http_submit : integer;
    function http_sites : integer;
    procedure HttpOnCommand( Sender : TObject; var S : string );
    procedure HttpOnRequestDone( Sender : TObject; RqType : THttpRequest; Error
      : Word );
    procedure SmtpOnRequestDone( Sender : TObject; RqType : TSmtpRequest; Error
      : Word );
    procedure SmtpOnDisplay( Sender : TObject; Msg : string );
    procedure SmtpOnHeaderLine( Sender : TObject; Msg : PChar; Size : Integer );
{$ENDIF}
{$IFNDEF LINUX}
    function ChangeActiveDrive( DriveNum : Byte ) : Boolean;
{$IFNDEF LINUX} overload;
    function ChangeActiveDrive( DriveLetter : Char ) : Boolean; overload;
{$ENDIF}
    function GetActiveDrive : Byte;
    function GetActiveDriveLetter : Char;
    function RefreshDrives : Boolean;
{$ENDIF}
    procedure Connect( );
    procedure Disconnect( );
    procedure SocketDataAvailable( Sender : TObject; Error
      : word );
    procedure IsConnected( Sender : TObject; Error
      : word );
    { FVC }
    procedure IsDisconnected( Sender : TObject; Error : Word );
    { end FVC }
    function SendHello(Command: String): Integer;
    function GetSites : Integer;
    function Proto : Integer;
    function Query(Command: String): Integer;
    function Read(DISC_ID: String): Integer;
    function Quit : Integer;
{$IFDEF INTERNAL-PARSER}
    procedure ParseCurrentEntry;
    procedure FormCurrentEntry;
{$ENDIF} // Now INTERNAL-PARSER doesn't disable LocalCDDB.dll functions
    //{$ELSE}
    function ParseEntry : integer;
    function FormEntry : integer;
    function SaveInfoToLocalCDDB : integer;
    function ReadInfoFromLocalCDDB : integer;
{$IFNDEF BCB}
    function FindMatchesFromLocalCDDB : TMatches;
{$ELSE}
    // The integers have to be typecast into pointers.
    // Real pointers cause extremely odd behavior. I wonder why.
    function FindMatchesFromLocalCDDB( Matches : Integer ) : Integer;
{$ENDIF}
    //{$ENDIF}
{$IFNDEF LINUX}
    property CdRoms : TCdRoms read FCdRoms;
{$ENDIF}
    property Server : TServer read FServer write FServer;
    property Servers[Index : integer] :
{$IFNDEF BCB}TServer{$ELSE}PServer{$ENDIF} read GetServerByIndex write
    SetServerByIndex;
    property State : integer read FState;
    property CurrentEntry[Index : integer] : string read GetEntryLine write
    SetEntryLine;
    property CDInfo : PCDInfo read GetCDInfo write SetCDInfo;
  published
    { Published declarations }
    property InternalTOCRetrieve : Boolean read FInternalTOCRetrieve write
      FInternalTOCRetrieve;
    property LocalCDDBPath : string read FLocalCDDBPath write FLocalCDDBPath;
    property LocalCDDBDLLPath : string read FLocalCDDBDLLPath write
      FLocalCDDBDLLPath;
    property NoteToUser : string read FNoteToUser write SetNoteToUser;
    property OnStatusMessage : TStatusEvent read FOnStatusMessage write
      FOnStatusMessage;
    property OnDataExchange : TStatusEvent read FOnDataExchange write
      FOnDataExchange;
    property OnMatch : TMatchEvent read FOnMatch write FOnMatch;

    property EmailUser : string read FUserEmailAddr write
      FUserEmailAddr;
    property EmailSubmit : string read FSubmitEmailAddr
      write FSubmitEmailAddr;
    property ServerAddr : string read FServerAddr write
      FServerAddr;
    property ServerAdditionalAddr : string read
      FServerAdditionalAddr write
      FServerAdditionalAddr;
    property ServerPort : string read FServerPort write
      FServerPort;
    property ServerType : TServerType read FServerType write
      FServerType;
    property ServerLatitude : string read FServerLatitude
      write FServerLatitude;
    property ServerLongitude : string read FServerLongitude
      write
      FServerLongitude;
    property ServerDescription : string read
      FServerDescription write
      FServerDescription;
    { FVC }
{$IFDEF HTTP-SUPPORT}
    property ProxyAddress : string read http_GetProxyAddress write
      http_SetProxyAddress;
    property ProxyPort : string read http_GetProxyPort write http_SetProxyPort;
{$ENDIF}
    { end FVC}
    property SubmissionType : TSubmissionType read FSubmissionType write
      FSubmissionType;
    property MailServerAddress : string read FMailServerAddr write
      FMailServerAddr;
    property MailServerPort : string read FMailServerPort write FMailServerPort;
    property ClientName : string read FClientName write
      FClientName;
    property ClientVersion : string read FClientVersion
      write FClientVersion;
    property ClientComments : string read FClientComments
      write FClientComments;
  end;

{$IFDEF LINUX}
procedure ZeroMemory( Destination : Pointer; Length : DWORD );
{$ENDIF}

procedure Register;
const
  //  EntryArrayLength = 512;

  CS_NOTCONNECTED = -1;
  CS_CONNECTED = 0;
  CS_SAIDHELLO = 1;
  CS_HELLOSUCCESS = 2;
  CS_MATCH = 3;
  CS_MULTIMATCH = 4;
  CS_NOMATCH = 5;
  CS_QUERYED = 6;

  CS_SITESASKED = 7;
  CS_SITESSUCCESS = 8;
  CS_SAIDPROTO = 9;
  CS_PROTOSET = 10;
  CS_SAIDREAD = 11;
  CS_READSUCCESS = 12;
  CS_READFAIL = 13;
  CS_HTTPSUBMIT = 14;
  CS_QUIT = 15;
  CS_HTTPERROR = 16;
  //  CS_CATSASKED = 15; //For lscat
  { FVC }
  CS_CONNECTED_READONLY = 17;
  CS_CONNECTED_READWRITE = 18;
  CS_SITESFAIL = 19;
  { end FVC }
  CS_SMTPSUBMIT = 20;
  CS_SMTPERROR = 21;

  SUCCESS = 0;
  FAIL = -1;
implementation
//{$IFNDEF INTERNAL-PARSER}
{$IFNDEF LINUX}
uses LocalCDDB;
//{$ENDIF}
{$ENDIF}

function BreakEmlAddr( Email : string ) : string;
var
  i : integer;
begin
  for i := 1 to length( Email ) do
  begin
    if Email[i] = '@' then
    begin
      Result := Copy( Email, 1, i - 1 ) + ' ' + Copy( Email, i + 1, length(
        Email )
        - i );
    end;
  end;
end;

{$IFDEF BCB}

function IncludeTrailingPathDelimiter( const S : string ) : string;
const PathDelim = '\';

  function IsPathDelimiter(const S: string; Index: Integer): Boolean;
  begin
    Result := (Index > 0) and (Index <= Length(S)) and (S[Index] = PathDelim)
      and (ByteType(S, Index) = mbSingleByte);
  end;

begin
  Result := S;
  if not IsPathDelimiter(Result, Length(Result)) then
    Result := Result + PathDelim;
end;
{$ENDIF}
{$IFNDEF BCB}
{$IFNDEF VER140} //VER140=Delphi 6
{$IFNDEF LINUX}

function IncludeTrailingPathDelimiter( const S : string ) : string;
begin
  Result := IncludeTrailingBackshlash( S );
end;
{$ENDIF}
{$ENDIF}
{$ENDIF}

{$IFDEF HTTP-SUPPORT}

procedure LoadStringListFromMemoryStream( Memo : TStringList; Stream :
  TMemoryStream );
var
  p, q, r : PChar;
begin
  p := Stream.Memory;
  q := p + Stream.Size - 1;
  r := p;
  while ( p <> nil ) and ( p < q ) do
  begin
    while ( p < q ) and ( p^ <> #13 ) and ( p^ <> #10 ) do
      Inc( p );
    Memo.Add( Copy( StrPas( r ), 1, p - r ) );
    if ( p[0] = #13 ) and ( p[1] = #10 ) then
      Inc( p, 2 )
    else
      Inc( p );
    r := p;
  end;
end;

function Encode( const msg : string ) : string;
var
  I : Integer;
begin
  Result := '';
  for I := 1 to Length( msg ) do
  begin
    if msg[I] = ' ' then
      Result := Result + '+'
    else
      if msg[I] in ['a'..'z', 'A'..'Z', '0'..'9'] then
        Result := Result + msg[I]
      else
        Result := Result + '%' + IntToHex( ord( msg[I] ), 2 );
  end;
end;
{$ENDIF}

function Left( Line : string; Count : Integer ) : string;
begin
  Result := Copy( Line, 1, Count );
end;

function Right( Line : string; Count : Integer ) : string;
begin
  Result := Copy( Line, Length( Line ) - Count + 1, Count );
end;

function FindSpace( Line : string ) : integer;
var
  i : integer;
begin
  for i := 1 to Length( Line ) do
  begin
    if Line[i] = ' ' then
    begin
      Result := i;
      exit;
    end;
  end;
  Result := Length( Line );
end;

function FindChar( Line : string; Charct : Char ) : integer;
var
  i : integer;
begin
  for i := 1 to Length( Line ) do
  begin
    if Line[i] = Charct then
    begin
      Result := i;
      exit;
    end;
  end;
  Result := Length( Line );
end;

function cddb_sum( n : integer ) : Integer;
begin
  Result := 0;
  while ( n > 0 ) do
  begin
    Result := Result + n mod 10;
    n := n div 10
  end
end;

function CalcDiscID( CdToc : TCdToc ) : Cardinal; stdcall; // DWord
var
  n, i, t : Cardinal;
begin
  i := 0;
  // t := 0; //I hope commenting out doesn't damage anything. I just can't stand compiler hints!
  n := 0;

  while i < CdToc.TracksOnCD do
  begin
    n := n + cddb_sum( ( CdToc.Tracks[i].M * 60 ) + CdToc.Tracks[i].S );
    i := i + 1;
  end;

  t := ( ( CdToc.LeadOut.M * 60 ) + CdToc.LeadOut.S ) -
    ( ( CdToc.Tracks[0].M * 60 ) + CdToc.Tracks[0].S );

  Result := ( ( n mod $FF ) shl 24 ) or ( t shl 8 ) or CdToc.TracksOnCD;
end;

function GenerateQueryString( CdToc : TCdToc ) : string;
var
  I : Integer;
begin
  // generate cddb query string
  // 1: cddb query <discid> <number of tracks>
  Result := Format( 'cddb query %s %d', [Lowercase( IntToHex( CalcDiscID( CDToc
      ), 8 ) ),
    CdToc.TracksOnCD] );
  // 2: <tracks offset 1> <tracks offset n>
  with CdToc do
    for I := 0 to TracksOnCD - 1 do
      with Tracks[I] do
        Result := Result + ' ' + IntToStr( ( M * 75 * 60 ) + ( S * 75 ) + F );
  // 3: <number of seconds>
  Result := Result + ' ' +
    IntToStr( ( CDToc.LeadOut.M * 60 ) + CdToc.LeadOut.S );
end;

function IsDigit( Ch : Char ) : Boolean;
begin
  Result := ( ch >= '0' ) and ( ch <= '9' );
end;

{$IFDEF LINUX}

procedure ZeroMemory( Destination : Pointer; Length : DWORD );
begin
  FillChar( Destination^, Length, 0 );
end;
{$ENDIF}

constructor TCddb.Create( AOwner : TComponent );
begin
  inherited Create( AOwner );
  FState := CS_NOTCONNECTED;
  FLoggedIn := False;
  ZeroMemory( @FServers, SizeOf( FServers ) );
  FCDDBSocket := {$IFNDEF USE-WSOCKET}TICSSocket{$ELSE}TWSocket{$ENDIF}.Create(
    nil );
  FCDDBSocket.OnDataAvailable := SocketDataAvailable;
  FCDDBSocket.OnSessionConnected := IsConnected;
  { FVC }
  FCDDBSocket.OnSessionClosed := IsDisconnected;
  { end FVC }
  FCDDBSocket.MultiThreaded := False;
  FCDDBSocket.LineMode := True;
{$IFNDEF USE-WSOCKET}
  FCDDBSocket.ComponentOptions := [isoSyncEvents];
{$ENDIF}
  FCDDBSocket.Proto := 'tcp';
  FCDDBSocket.Port := '8880';
  FCDDBSocket.Addr := 'freedb.freedb.org';
  FNoteToUser :=
    'Submitted using Ari''s freedb component 0.1.70. Bugs? megari@mbnet.fi';
  FClientName := 'Ari''s freedb component';
  FClientVersion := 'v0.1.70 Release';
  //  FClientComments := 'using Ari''s freedb component v0.1.70 Release';
  FServerAdditionalAddr := '/~cddb/cddb.cgi';
{$IFNDEF LINUX}
  if InterfaceInstalled = False then
  begin
    FInternalTOCRetrieve := False;

  end
  else
  begin
    FInternalTOCRetrieve := True;

    GetCdRomDrives( FCdRoms );
    if FCdRoms.CdRomCount > 0 then
    begin
      // We'll read the first drive on create by default
      ReadCDToc( FCdRoms, 0, FCDInfo.CDToc );
      FCdRoms.ActiveCdRom := 0;
    end;
  end;
{$ENDIF}
  FLocalCDDBDLLPath := '.\LocalCDDB.dll';
  FLocalCDDBPath := '.\';
{$IFDEF HTTP-SUPPORT}
  FStreamIn := TMemoryStream.Create;
  FStreamOut := TMemoryStream.Create;
  FHttpCli := THttpCli.Create( nil );
  FHttpCli.OnCommand := HttpOnCommand;
  FHttpCli.OnRequestDone := HttpOnRequestDone;
  FHttpCli.SendStream := FStreamOut;
  FHttpCli.RcvdStream := FStreamIn;
{$ENDIF}
  FSubmissionType := TEST;
  FSubmitEmailAddr := 'test-submit@freedb.org';
  FSmtpCli := TSmtpCli.Create( nil );
  FSmtpCli.OnRequestDone := SmtpOnRequestDone;
  FSmtpCli.OnDisplay := SmtpOnDisplay;
  FSmtpCli.OnHeaderLine := SmtpOnHeaderLine;
  FMailServerPort := FSmtpCli.Port; //'smtp'; //'25';  //The standard SMTP port

end;

destructor TCddb.Destroy;
begin
  FCDDBSocket.Free;
  FSmtpCli.Free;
{$IFDEF HTTP-SUPPORT}
  FHTTPCli.Free;
  FStreamOut.Free;
  FStreamIn.Free;
{$ENDIF}
  inherited Destroy;
end;

procedure TCddb.Connect( );
begin
  if FServerType = CDDBP then
  begin
    FCDDBSocket.Proto := 'tcp';
    FCDDBSocket.Port := FServerPort;
    FCDDBSocket.Addr := FServerAddr;
    FCDDBSocket.Connect( );
  end{$IFNDEF HTTP-SUPPORT};
{$ELSE}
  else
  begin
    //Nothing to do, just for the ease of use for developers
  end;
{$ENDIF}
end;

procedure TCddb.Disconnect( );
begin
  if Assigned( FOnStatusMessage ) then
    OnStatusMessage( Self, 'Closing connection' );

  if FCDDBSocket.State <> wsClosed then
  begin
    FCDDBSocket.Close;
  end;
  if Assigned( FOnStatusMessage ) then
    OnStatusMessage( Self, 'Connection closed' );
end;

procedure TCddb.SocketDataAvailable( Sender : TObject; Error : word );
var
  Input : string;
  TempResults : TParseResults;
begin
  Input := Trim( FCDDBSocket.ReceiveStr( ) );
  if Assigned( FOnDataExchange ) then
    OnDataExchange( Self, Input );

  { It seems that the results returned by parser functions can
    be ignored on most cases because it is best if the parsers fire
    OnStatusMessage themselves. }

  { Parser: If FState is CS_CONNECTED then most probably we should assume
    it is the sign-on banner. If the parsing of MOTD fails, we call the general
    parser with some predefined error codes(No more connections, for instance)
    and general error code parsing. }
  if FState = CS_CONNECTED then
  begin
    TempResults := ParseSignOnBanner( Input );
  end;

  { If FState is CS_SAIDHELLO then the cddb hello has been sent and we should
    try to parse the response. The parser sets FState to CS_HELLOSUCCESS if
    the response is a positive kind, else set CS_CONNECTED. The parser should
    maybe also call the general parser to check if the response is good. }

  if FState = CS_SAIDHELLO then
  begin
    TempResults := ParseHello( Input );
  end;

  { And the same type of behavior for the other commands. I'll add them later.}
  if FState = CS_SITESASKED then
  begin
    TempResults := ParseSites( Input );
  end;

  if FState = CS_SAIDPROTO then
  begin
    TempResults := ParseProto( Input );
  end;

  if FState = CS_QUERYED then
  begin
    TempResults := ParseQuery( Input );
  end;

  if FState = CS_SAIDREAD then
  begin
    TempResults := ParseRead( Input );
  end;

  if FState = CS_QUIT then
  begin
    //Disconnect;
    if Assigned( FOnStatusMessage ) then
      OnStatusMessage( Self, 'Connection closed' );
    FState := CS_NOTCONNECTED;
  end;

end;

procedure TCddb.IsConnected( Sender : TObject; Error : word );
begin
  FState := CS_CONNECTED;
end;

{ FVC }

procedure TCddb.IsDisconnected;
begin
  FState := CS_NOTCONNECTED;
end;
{ end FVC }

function TCddb.SendHello(Command: String): Integer;
var
  SendCMD: String;
begin
  if not FState >= CS_CONNECTED then
  begin
    Connect( );
    //  BreakEmlAddr( FUserEmailAddr );
  end;
  SendCMD := 'cddb hello ' + Command + #13#10;
  Result := FCDDBSocket.SendStr( SendCMD );
  if Result <> FAIL then
  begin
    FState := CS_SAIDHELLO;
    if Assigned( FOnStatusMessage ) then
      OnStatusMessage( Self, 'Sending hello...' );
    if Assigned( FOnDataExchange ) then
      OnDataExchange( Self, Command );
  end
  else
  begin
    if Assigned( FOnStatusMessage ) then
      OnStatusMessage( Self,
        'CDDB Component Internal Error: TICSSocket.SendStr failed' );
  end;
end;

function TCDDB.GetSites: Integer;
begin
  if not FState >= CS_CONNECTED then
  begin
    Connect( );
  end;

  Result := FCDDBSocket.SendStr( 'sites' + #13#10 );
  if Result <> FAIL then
  begin
    FState := CS_SITESASKED;
    if Assigned( FOnStatusMessage ) then
      OnStatusMessage( Self, 'Getting sites...' );
    if Assigned( FOnDataExchange ) then
      OnDataExchange( Self, 'sites' + #13#10 );
  end
  else
  begin
    if Assigned( FOnStatusMessage ) then
      OnStatusMessage( Self,
        'CDDB Component Internal Error: TICSSocket.SendStr failed' );
    { FVC }
    FState := CS_SITESFAIL;
    { end FVC }
  end;
end;

function TCDDB.Parse( Line : string ) : TParseResults;
var
  Code : Integer;
  Status : string;
begin
  Code := StrToInt( Left( Line, 3 ) );

  case Code of
    402 :
      begin
        Status := 'Server error';
        Result := [CantPerform, Ready];
        if Assigned( FOnStatusMessage ) then
          OnStatusMessage( Self, Status );
        exit;
      end;
    408 :
      begin
        Status := 'CGI environment error';
        Result := [CantPerform, Ready];
        if Assigned( FOnStatusMessage ) then
          OnStatusMessage( Self, Status );
        exit;
      end;
    500 :
      begin
        Status :=
          'Command syntax error, command unknown, command unimplemented';
        Result := [SyntaxError, Ready];
        if Assigned( FOnStatusMessage ) then
          OnStatusMessage( Self, Status );
        exit;
      end;
    530 :
      begin
        Status := 'Server error, server timeout';
        Result := [SyntaxError, Ready];
        FState := CS_NOTCONNECTED;
        FLoggedIn := False;
        if Assigned( FOnStatusMessage ) then
          OnStatusMessage( Self, Status );
        exit;
      end;
  end;

  case ( Code div 100 ) of
    1 :
      begin
        Status := 'Informative message';
        Result := [InformativeMessage];
      end;
    2 :
      begin
        Status := 'Command OK';
        Result := [OK];
      end;
    3 :
      begin
        Status := 'Command OK so far';
        Result := [OKSoFar];
      end;
    4 :
      begin
        Status := 'Command OK, but cannot be performed';
        Result := [CantPerform];
      end;
    5 :
      begin
        Status := 'Command unimplemented, incorrect, or program error';
        Result := [SyntaxError];
      end;
  end;
  case Code - ( ( Code div 100 ) * 100 ) of
    0 :
      begin
        Status := Status + ', ready for further commands';
        Result := Result + [Ready];
      end;
    10 :
      begin
        Status := Status + ', more server-to-client output follows';
        Result := Result + [MoreInputCToS];
      end;
    20 :
      begin
        Status := Status + ', more client-to-server input follows';
        Result := Result + [MoreInputSToC];
      end;
    30 :
      begin
        Status := Status + ', connection will close';
        Result := Result + [ConnectionCloses];
        FState := CS_NOTCONNECTED;
        FLoggedIn := False;
      end;
  end;
  if Assigned( FOnStatusMessage ) then
    OnStatusMessage( Self, Status );
end;

function TCDDB.ParseSignOnBanner( Line : string ) : TParseResults;
var
  Code : Integer;
begin
  Code := StrToInt( Left( Line, 3 ) );
  case Code of
    200 :
      begin
        Result := [OK, Ready];
        FLoggedIn := False;
        if Assigned( FOnStatusMessage ) then
          OnStatusMessage( Self, 'OK, read/write allowed' );
        { FVC }
        FState := CS_CONNECTED_READWRITE;
        { end FVC }
      end;
    201 :
      begin
        Result := [OK, Ready];
        FLoggedIn := False;
        if Assigned( FOnStatusMessage ) then
          OnStatusMessage( Self, 'OK, read only' );
        { FVC }
        FState := CS_CONNECTED_READONLY;
        { end FVC }
      end;
    432 :
      begin
        Result := [CantPerform, ConnectionCloses];
        FState := CS_NOTCONNECTED;
        FLoggedIn := False;
        if Assigned( FOnStatusMessage ) then
          OnStatusMessage( Self, 'No connections allowed: permission denied' );
      end;
    433 :
      begin
        Result := [CantPerform, ConnectionCloses];
        FState := CS_NOTCONNECTED;
        FLoggedIn := False;
        if Assigned( FOnStatusMessage ) then
          OnStatusMessage( Self,
            'No connections allowed: X users allowed, Y currently active' );
      end;
    434 :
      begin
        Result := [CantPerform, ConnectionCloses];
        FState := CS_NOTCONNECTED;
        FLoggedIn := False;
        if Assigned( FOnStatusMessage ) then
          OnStatusMessage( Self, 'No connections allowed: system load too high'
            );
      end;
  else
    begin
      Result := Parse( Line );
    end;
  end;
end;

function TCDDB.ParseHello( Line : string ) : TParseResults;
var
  Code : Integer;
begin
  Code := StrToInt( Left( Line, 3 ) );

  case Code of
    200 :
      begin
        FState := CS_HELLOSUCCESS;
        Result := [OK, Ready];
        FLoggedIn := True;
        if Assigned( FOnStatusMessage ) then
          OnStatusMessage( Self, 'Handshake successful' );
      end;
    431 :
      begin
        FState := CS_NOTCONNECTED;
        Result := [CantPerform, ConnectionCloses];
        FLoggedIn := False;
        if Assigned( FOnStatusMessage ) then
          OnStatusMessage( Self, 'Handshake not successful, closing connection'
            );
      end;
    402 :
      begin
        FState := CS_HELLOSUCCESS;
        Result := [CantPerform, Ready];
        FLoggedIn := True;
        if Assigned( FOnStatusMessage ) then
          OnStatusMessage( Self, 'Already shook hands' );
      end;
  else
    begin
      Result := Parse( Line );
    end;
  end;
end;

(* The old one, Frank made this better
function TCDDB.ParseSites( Line : string ) : TParseResults;
var
  Code, TempLine, Templine2 : string;
  i : integer;
begin
  Code := Left( Line, 3 );
  if Left( Line, 1 ) <> '.' then
  begin
    if Code = '210' then
    begin
      if Assigned( FOnStatusMessage ) then
        OnStatusMessage( Self, 'OK, receiving sites' );
      Result := [OK, MoreInputSToC];
      ZeroMemory( @FServers, SizeOf( FServers ) );
    end
    else
      if Code = '401' then
      begin
        if Assigned( FOnStatusMessage ) then
          OnStatusMessage( Self, 'No site information available' );
        Result := [CantPerform, Ready];
      end
      else
      begin
        { This block of code is total crap. I've got to optimize this when I
          have the time to rethink this. }

        for i := 0 to 99 do
        begin
          if FServers[i].Address = '' then
            break;
        end;

        TempLine := Trim( Left( Line, FindSpace( Line ) ) );
        TempLine2 := Trim( Right( Line, Length( Line ) - FindSpace( Line ) ) );
        FServers[i].Address := TempLine;

        TempLine := Trim( Left( TempLine2, FindSpace( TempLine2 ) ) );
        TempLine2 := Trim( Right( TempLine2, Length( TempLine2 ) - FindSpace(
          TempLine2 ) ) );
        if Lowercase( TempLine ) = 'cddbp' then
        begin
          FServers[i].ServerType := CDDBP;
        end{$IFNDEF HTTP-SUPPORT};
{$ENDIF}
{$IFDEF HTTP-SUPPORT}
    else
      if Lowercase( TempLine ) = 'http' then
      begin
        FServers[i].ServerType := HTTP;
      end;
{$ENDIF}

      TempLine := Trim( Left( TempLine2, FindSpace( TempLine2 ) ) );
      TempLine2 := Trim( Right( TempLine2, Length( TempLine2 ) - FindSpace(
        TempLine2 ) ) );
      FServers[i].Port := StrToInt( TempLine );

      TempLine := Trim( Left( TempLine2, FindSpace( TempLine2 ) ) );
      TempLine2 := Trim( Right( TempLine2, Length( TempLine2 ) - FindSpace(
        TempLine2 ) ) );
      FServers[i].AdditionalAddress := TempLine;

      TempLine := Trim( Left( TempLine2, FindSpace( TempLine2 ) ) );
      TempLine2 := Trim( Right( TempLine2, Length( TempLine2 ) - FindSpace(
        TempLine2 ) ) );
      FServers[i].Location.Latitude := TempLine;

      TempLine := Trim( Left( TempLine2, FindSpace( TempLine2 ) ) );
      TempLine2 := Trim( Right( TempLine2, Length( TempLine2 ) - FindSpace(
        TempLine2 ) ) );
      FServers[i].Location.Longitude := TempLine;

      FServers[i].Location.Description := TempLine2;

      Result := [OK, MoreInputSToC];
  end;
end
else
  begin
    FState := CS_SITESSUCCESS;
    Result := [OK, Ready];
    if Assigned( FOnStatusMessage ) then
      OnStatusMessage( Self, 'Got sites' );
  end;
end;
*)

function TCDDB.ParseSites( Line : string ) : TParseResults;
var
  TheLine : array[0..1023] of char;
  StartPtr, NextPtr : PChar;
  Code {, TempLine, Templine2} : string;
  i : integer;
  { FVC -----------------------------------------------}

  function NextPart : string;
  begin
    StartPtr := NextPtr + 1;
    NextPtr := StrPos( StartPtr, ' ' );
    if NextPtr <> nil then
      NextPtr^ := #0;
    Result := StrPas( StartPtr );
  end; {NextPart}
  { end FVC -------------------------------------------}
begin
  Code := Left( Line, 3 );
  if Left( Line, 1 ) <> '.' then
  begin
    if Code = '210' then
    begin
      if Assigned( FOnStatusMessage ) then
        OnStatusMessage( Self, 'OK, receiving sites' );
      Result := [OK, MoreInputSToC];
      ZeroMemory( @FServers, SizeOf( FServers ) );
    end
    else
      if Code = '401' then
      begin
        if Assigned( FOnStatusMessage ) then
          OnStatusMessage( Self, 'No site information available' );
        Result := [CantPerform, Ready];
        { FVC }
        FState := CS_SITESFAIL;
        { end FVC }
      end
      else
      begin
        { This block of code is total crap. I've got to optimize this when I
          have the time to rethink this. }
{ FVC : having retought :-) }
        i := 0;
        while FServers[i].Address <> '' do
          Inc( I );

        StartPtr := @TheLine;
        StrPCopy( StartPtr, Line );
        NextPtr := StartPtr - 1;

        FServers[i].Address := NextPart;
{$IFDEF HTTP-SUPPORT}
        //if FServerType = HTTP then  //Problems when using the correct proto
        if lowercase( NextPart ) = 'http' then
          FServers[i].ServerType := HTTP
        else
{$ENDIF}
          FServers[i].ServerType := CDDBP;
        FServers[i].Port := StrToInt( NextPart );
{$IFDEF HTTP-SUPPORT}
        if FServerType = HTTP then
          FServers[i].AdditionalAddress := NextPart
        else
{$ENDIF}
          FServers[i].AdditionalAddress := '-';
        FServers[i].Location.Latitude := NextPart;
        FServers[i].Location.Longitude := NextPart;

        StartPtr := NextPtr + 1;
        FServers[i].Location.Description := StrPas( StartPtr );
        { end FVC }
        Result := [OK, MoreInputSToC];
      end;
  end
  else
  begin
    FState := CS_SITESSUCCESS;
    Result := [OK, Ready];
    if Assigned( FOnStatusMessage ) then
      OnStatusMessage( Self, 'Got sites' );
  end;
end;

function TCDDB.Proto : Integer;
begin
  Result := FAIL;
  if not FState >= CS_CONNECTED then
  begin
    if Assigned( FOnStatusMessage ) then
      OnStatusMessage( Self, 'Not connected' );
    Exit;
  end;

  Result := FCDDBSocket.SendStr( 'proto 5' + #13#10 );
  if Result <> FAIL then
  begin
    FState := CS_SAIDPROTO;
    if Assigned( FOnStatusMessage ) then
      OnStatusMessage( Self, 'Setting protocol level' );
    if Assigned( FOnDataExchange ) then
      OnDataExchange( Self, 'proto 5' + #13#10 );
  end
  else
  begin
    if Assigned( FOnStatusMessage ) then
      OnStatusMessage( Self,
        'CDDB Component Internal Error: TICSSocket.SendStr failed' );
  end;
end;

function TCDDB.ParseProto( Line : string ) : TParseResults;
var
  Code : integer;
begin
  Code := StrToInt( Left( Line, 3 ) );
  case Code of
    201 :
      begin
        FState := CS_PROTOSET;
        Result := [OK, Ready];
        if Assigned( FOnStatusMessage ) then
          OnStatusMessage( Self, 'OK, protocol level now: 5' );
      end;
    501 :
      begin
        FState := CS_CONNECTED;
        Result := [SyntaxError, Ready];
        if Assigned( FOnStatusMessage ) then
          OnStatusMessage( Self, 'Illegal protocol level' );
      end;
    502 :
      begin
        FState := CS_PROTOSET;
        Result := [SyntaxError, Ready];
        if Assigned( FOnStatusMessage ) then
          OnStatusMessage( Self, 'Protocol level already 5' );
      end;
  else
    begin
      Result := Parse( Line );
    end;
  end;
end;

function TCDDB.Query(Command: String) : Integer;
const
  CD_TRACKS = 13;
var
  i : integer;
begin
  Result := FAIL;

  if not FState >= CS_CONNECTED then
  begin
    if Assigned( FOnStatusMessage ) then
      OnStatusMessage( Self, 'Not connected' );
    Exit;
  end;

  if not FLoggedIn then
  begin
    if Assigned( FOnStatusMessage ) then
      OnStatusMessage( Self, 'Not logged in' );
    Exit;
  end;

  Result := FCDDBSocket.SendStr( Command + #13#10 );
  if Result <> FAIL then
  begin
    FState := CS_QUERYED;
    if Assigned( FOnStatusMessage ) then
      OnStatusMessage( Self, 'Querying CD' );
    if Assigned( FOnDataExchange ) then
      OnDataExchange( Self, Command + #13#10 );
  end
  else
  begin
    if Assigned( FOnStatusMessage ) then
      OnStatusMessage( Self,
        'CDDB Component Internal Error: TICSSocket.SendStr failed' );
  end;

end;

function TCDDB.Read(DISC_ID: String): Integer;
var
  Command : string;
begin
  Result := FAIL;

  if not FState >= CS_CONNECTED then
  begin
    if Assigned( FOnStatusMessage ) then
      OnStatusMessage( Self, 'Not connected' );
    Exit;
  end;

  if not FLoggedIn then
  begin
    if Assigned( FOnStatusMessage ) then
      OnStatusMessage( Self, 'Not logged in' );
    Exit;
  end;

  if FState = CS_NOMATCH then
  begin
    if Assigned( FOnStatusMessage ) then
      OnStatusMessage( Self,
        'Can''t perform a CDDB READ without a successful CDDB QUERY!' );
    Result := FAIL;
    exit;
  end;

  // cddb read categ discid

  Command := Format( 'cddb read %s %s', [FCDInfo.Category, LowerCase(
      Trim( DISC_ID ) )] );

  Result := FCDDBSocket.SendStr( Command + #13#10 );
  if Result <> FAIL then
  begin
    FState := CS_SAIDREAD;
    if Assigned( FOnStatusMessage ) then
      OnStatusMessage( Self, 'Reading CD info' );
    if Assigned( FOnDataExchange ) then
      OnDataExchange( Self, Command + #13#10 );
  end

  else
  begin
    if Assigned( FOnStatusMessage ) then
      OnStatusMessage( Self,
        'CDDB Component Internal Error: TICSSocket.SendStr failed' );
  end;
end;

function TCDDB.ParseQuery( Line : string ) : TParseResults;
var
  Code, i : Integer;
begin
  // A problem with this function: what if an error not defined here occurs?
  // (The one below was fixed 24 December 2001 in version 0.1.40, so no problem
  // anymore)
  if {(Left( Line, 1 ) <> '.') or}( Left( Line, 3 ) = '200' ) or ( Left( Line, 3
    ) = '210' )
  or ( Left( Line, 3 ) = '211' ) or ( Left( Line, 3 ) = '202' ) or ( Left( Line,
    3 ) = '403' )
    or ( Left( Line, 3 ) = '409' ) then
  begin
    Code := StrToInt( Left( Line, 3 ) );
    case Code of
      200 :
        begin
          FState := CS_MATCH;
          Result := [OK, Ready];
          if Assigned( FOnStatusMessage ) then
            OnStatusMessage( Self, 'Found exact match' );
          ZeroMemory( @FMatches, SizeOf( FMatches ) );
          FMatches[0] := Trim( Right( Line, Length( Line ) - 4 ) );
          i := 0;
          OnMatch( Self, FMatches, i );
          // If i = 0 then it's OK, if it's -1 then it wasn't accepted by the user.
          if i <> -1 then
          begin
            // ZeroMemory( @FCdInfo, SizeOf( FCdInfo ) );
            // Category and proper discid is all we need for a successful cddb read

            FCDInfo.Category := Trim( Left( FMatches[0], FindSpace(
              FMatches[0] ) ) );
            FCDInfo.DiscID := Format( '%8.8x', [CalcDiscID( FCDInfo.CDTOC )] );
          end { FVC }
          else
            FState := CS_NOMATCH;
          { end FVC }
        end;
      210 :
        begin
          Result := [OK, MoreInputSToC];
          if Assigned( FOnStatusMessage ) then
            OnStatusMessage( Self, 'Found exact matches' );
          ZeroMemory( @FMatches, SizeOf( FMatches ) );
          if Assigned( FOnStatusMessage ) then
            OnStatusMessage( Self, 'OK, receiving matches' );
        end;
      211 :
        begin
          Result := [OK, MoreInputSToC];
          if Assigned( FOnStatusMessage ) then
            OnStatusMessage( Self, 'Found inexact matches' );
          ZeroMemory( @FMatches, SizeOf( FMatches ) );
          if Assigned( FOnStatusMessage ) then
            OnStatusMessage( Self, 'OK, receiving matches' );
        end;
      202 :
        begin
          Result := [OK, Ready];
          FState := CS_NOMATCH;
          if Assigned( FOnStatusMessage ) then
            OnStatusMessage( Self, 'No match found' );
        end;
      403 :
        begin
          Result := [CantPerform, Ready];
          FState := CS_NOMATCH;
          if Assigned( FOnStatusMessage ) then
            OnStatusMessage( Self, 'Database entry is corrupt' );
        end;
      409 :
        begin
          Result := [CantPerform, Ready];
          FState := CS_NOMATCH;
          FLoggedIn := False;
          if Assigned( FOnStatusMessage ) then
            OnStatusMessage( Self, 'No handshake' );
        end;

    end;
  end
  else
    if not IsDigit( Line[1] ) then
    begin
      if ( Left( Line, 1 ) = '.' ) then
      begin
        FState := CS_MULTIMATCH;
        Result := [OK, Ready];
        if Assigned( FOnStatusMessage ) then
          OnStatusMessage( Self, 'Received matches' );
        i := 0;
        OnMatch( Self, FMatches, i );
        if i <> -1 then
        begin
          // ZeroMemory( @FCdInfo, SizeOf( FCdInfo ) );
          // Category is all we need for a successful cddb read
          FCDInfo.Category := Left( FMatches[i], FindSpace( FMatches[i] ) );
          // We need to set a temporary DiscID for Read command
          FCDInfo.DiscID := Left( Right( FMatches[i], Length( FMatches[i] ) -
            FindSpace( FMatches[i] ) ), 8 );
          { FVC }
          FState := CS_MATCH;
          { end FVC }
        end
        else
        begin
          FState := CS_NOMATCH;
          Result := [OK, Ready];
        end;
      end
      else
      begin
        for i := 0 to 99 do
        begin
          if FMatches[i] = '' then
            break;
        end;

        FMatches[i] := Trim( Line );
        Result := [OK, MoreInputSToC];
      end;
    end
    else
    begin
      Result := Parse( Line );
    end;

end;

function TCDDB.ParseRead( Line : string ) : TParseResults;
var
  i, Code : integer;
  SCode : string;
begin
  SCode := Left( Line, 3 );
  if ( SCode = '210' ) or ( SCode = '401' ) or ( SCode = '402' ) or ( SCode =
    '403' ) or ( SCode = '409' ) then
  begin
    Code := StrToInt( Left( Line, 3 ) );
    case Code of
      210 :
        begin
          if Assigned( FOnStatusMessage ) then
            OnStatusMessage( Self, 'OK, CDDB database entry follows' );
          ZeroMemory( @FCurrentEntry, SizeOf( FCurrentEntry ) );
          Result := [OK, MoreInputSToC];
        end;
      401 :
        begin
          // Shouldn't happen, eh?
          Result := [CantPerform, Ready];
          FState := CS_READFAIL;
          if Assigned( FOnStatusMessage ) then
            OnStatusMessage( Self, 'Specified CDDB entry not found' );
        end;
      402 :
        begin
          Result := [CantPerform, Ready];
          FState := CS_READFAIL;
          if Assigned( FOnStatusMessage ) then
            OnStatusMessage( Self, 'Server error' );
        end;
      403 :
        begin
          Result := [CantPerform, Ready];
          FState := CS_READFAIL;
          if Assigned( FOnStatusMessage ) then
            OnStatusMessage( Self, 'Database entry is corrupt' );
        end;
      409 :
        begin
          Result := [CantPerform, Ready];
          FState := CS_READFAIL;
          FLoggedIn := False;
          if Assigned( FOnStatusMessage ) then
            OnStatusMessage( Self, 'No handshake' );
        end;
    end;
  end
  else
    if Left( Line, 1 ) = '.' then
    begin
      FState := CS_READSUCCESS;
      Result := [OK, Ready];
      if Assigned( FOnStatusMessage ) then
        OnStatusMessage( Self, 'Entry read' );
    end
    else
      // Lines starting with the following letters are the ONLY choice! Really!
      // (I mean, of course, database entries)
      if ( Left( Line, 1 ) = '#' ) or ( Left( Line, 1 ) = 'T' ) or ( Left( Line,
        1 ) = 'D' ) or ( Left( Line, 1 ) = 'E' ) or ( Left( Line, 1 ) = 'P' )
          then
      begin
        for i := 0 to EntryArrayLength - 1 do
        begin
          if FCurrentEntry[i] = '' then
            break;
        end;
        FCurrentEntry[i] := Trim( Line );
        Result := [OK, MoreInputSToC];
      end
      else
      begin
        FState := CS_READFAIL;
        Result := Parse( Line );
      end;
end;

{$IFDEF INTERNAL-PARSER}
{$R-}

procedure TCddb.ParseCurrentEntry;
var
  i,
    TrackNum,
    Separation : integer;
  Track,
    RightPart : string;
  TempCat : string;

  function FixBackSlashes( Line : string ) : string;
  var
    Location : integer;
  begin
    { changes all "\n"s to #13#10 }
    Location := Pos( '\n', Line );
    while ( Location > 0 ) do
    begin
      Line := Left( Line, Location - 1 ) + #13#10 + Right(
        Line, Length( Line ) - Location - 1 );
      Location := Pos( '\n', Line );
    end;
    Location := Pos( '\t', Line );
    while ( Location > 0 ) do
    begin
      Line := Left( Line, Location - 1 ) + #9 + Right(
        Line, Length( Line ) - Location - 1 );
      Location := Pos( '\t', Line );
    end;
    Result := Line;
  end;

begin
  //TrackNum := 0;
  //We don't want to lose the category, do we?
  TempCat := FCDInfo.Category;
  ZeroMemory( @FCDInfo, SizeOf( FCDInfo ) );
  RefreshDrives; //We get proper TOC data for the current entry.
  FCDInfo.Category := TempCat;

  for i := 0 to EntryArrayLength - 1 do
  begin
    if FCurrentEntry[i] <> '' then
    begin
      if FCurrentEntry[i][1] = '#' then
      begin
        if Left( FCurrentEntry[i], Length( '# Revision: ' ) ) = '# Revision: '
          then
        begin
          FCDInfo.Revision := StrToInt( Right( FCurrentEntry[i], Length(
            FCurrentEntry[i] ) - Length( '# Revision: ' ) ) );
        end;
        // None...
        { FVC
        if Assigned( FOnStatusMessage ) then
          OnStatusMessage( Self, 'Comment' );
          end FVC }
      end
      else
        if Uppercase( Left( FCurrentEntry[i], Length( 'DISCID' ) ) ) = 'DISCID'
          then
        begin
          // We've already got the discid! No action taken.
          { FVC
          if Assigned( FOnStatusMessage ) then
            OnStatusMessage( Self, 'DiscID' );
            end FVC }
        end
        else
          if Uppercase( Left( FCurrentEntry[i], Length( 'DTITLE' ) ) ) =
            'DTITLE' then
          begin
            //Parse the Artist/Title line
            (* Remplaced with a more error-tolerant one
            FCDInfo.Artist := Right( Left( FCurrentEntry[i], FindChar(
              FCurrentEntry[i], '/' ) - 2 ), Length( Left( FCurrentEntry[i],
              FindChar(
              FCurrentEntry[i], '/' ) - 2 ) ) - Length( 'DTITLE=' ) );

            {
            if Assigned( FOnStatusMessage ) then
              OnStatusMessage( Self, 'Artist: ' + FCDInfo.Artist );
              }

            FCDInfo.Title := Right( FCurrentEntry[i], Length(
              FCurrentEntry[i] ) - FindChar( FCurrentEntry[i], '/' ) - 1 );

            {
            if Assigned( FOnStatusMessage ) then
              OnStatusMessage( Self, 'Title: ' + FCDInfo.Title );
              }
            if FindChar( FCurrentEntry[i], '/' ) <> Length( FCurrentEntry[i] ) then}
            begin
              FCDInfo.Artist := Right( Left( FCurrentEntry[i], FindChar(
                FCurrentEntry[i], '/' ) - 2 ), Length( Left( FCurrentEntry[i],
                FindChar(
                FCurrentEntry[i], '/' ) - 2 ) ) - Length( 'DTITLE=' ) );
            end
            else
            begin
              FCDInfo.Artist := '';
            end;

            {
            if Assigned( FOnStatusMessage ) then
              OnStatusMessage( Self, 'Artist: ' + FCDInfo.Artist );
              }

            if FindChar( FCurrentEntry[i], '/' ) <> Length( FCurrentEntry[i] )
              then
            begin
              FCDInfo.Title := Right( FCurrentEntry[i], Length(
                FCurrentEntry[i] ) - FindChar( FCurrentEntry[i], '/' ) - 1 );
            end
            else
            begin
              FCDInfo.Title := Right( FCurrentEntry[i], Length(
                FCurrentEntry[i] ) - Length( 'DTITLE=' ) );
            end;
            *)
            { FVC }
            {
              changed the original code because :
              1. it is possible to have two or more lines with the same
                 keyword. The contents of the second line have to be added
                 to the previous line.
              2. look for ' / ' in stead of '/' because the use of '/' inside
                 the artist name is allowed and doesn't necessarily mean a
                 separator between title and artist.
            }
            RightPart := Right( FCurrentEntry[i], Length( FCurrentEntry[i] ) -
              Length( 'DTITLE=' ) );
            Separation := Pos( ' / ', RightPart );
            if Separation = 0 then { no separator found }
              if FCDInfo.Artist = '' then
                FCDInfo.Artist := RightPart
              else
                FCDInfo.Title := FCDInfo.Title + RightPart
            else
            begin
              FCDInfo.Artist := FixBackSlashes( FCDInfo.Artist + Left(
                RightPart, Separation - 1
                ) );
              FCDInfo.Title := FixBackSlashes( Right( RightPart, Length(
                RightPart ) - Separation
                - 2 ) );
            end; {if}
            { end FVC }
          end
          else
            if Uppercase( Left( FCurrentEntry[i], Length( 'DYEAR' ) ) ) =
              'DYEAR' then
            begin
              FCDInfo.Year := FixBackSlashes( Right( FCurrentEntry[i], Length(
                FCurrentEntry[i]
                )
                -
                Length( 'DYEAR=' ) ) );
            end
            else
              if Uppercase( Left( FCurrentEntry[i], Length( 'DGENRE' ) ) ) =
                'DGENRE' then
              begin
                FCDInfo.Genre := FixBackSlashes( Right( FCurrentEntry[i],
                  Length(
                  FCurrentEntry[i] )
                  -
                  Length( 'DGENRE=' ) ) );
              end
              else
                if Uppercase( Left( FCurrentEntry[i], Length( 'TTITLE' ) ) ) =
                  'TTITLE' then
                begin
                  { FVC }
                  Separation := Pos( '=', FCurrentEntry[i] );
                  Track := FCurrentEntry[i][7];
                  if Separation = 9 then
                    Track := Track + FCurrentEntry[i][8];
                  TrackNum := StrToInt( Track );
                  RightPart := Right( FCurrentEntry[i],
                    Length( FCurrentEntry[i] ) - Separation );
                  FCDInfo.Tracks[TrackNum] := FixBackSlashes(
                    FCDInfo.Tracks[TrackNum] +
                    RightPart );
                  { end FVC }
                  {
                  if FCurrentEntry[i][9] = '=' then
                    FCDInfo.Tracks[TrackNum] := Right( FCurrentEntry[i],
                      Length(
                      FCurrentEntry[i] ) -
                      Length( 'TTITLExx=' ) )
                  else
                    FCDInfo.Tracks[TrackNum] := Right( FCurrentEntry[i],
                      Length(
                      FCurrentEntry[i] ) -
                      Length( 'TTITLEx=' ) );
                  Inc( TrackNum );
                  }
                end
                else
                  if Uppercase( Left( FCurrentEntry[i], Length( 'EXTD' ) ) ) =
                    'EXTD' then
                  begin
                    FCDInfo.AddAlbumInfo := FixBackSlashes( { FVC }
                      FCDInfo.AddAlbumInfo +
                      { end FVC }
                      Right( FCurrentEntry[i], Length( FCurrentEntry[i] )
                      - Length( 'EXTD=' ) ) );
                  end
                  else
                    if Uppercase( Left( FCurrentEntry[i], Length( 'EXTT' ) ) )
                      =
                      'EXTT' then
                    begin
                      (*
                      if FCurrentEntry[i][7] = '=' then
                        FCDInfo.AddTrkInfo[StrToInt( Right( Left(
                          FCurrentEntry[i], 6 ), 2 ) )] := Right(
                            FCurrentEntry[i],
                          Length(
                          FCurrentEntry[i] ) -
                          Length( 'EXTTxx=' ) )
                      else
                        FCDInfo.AddTrkInfo[StrToInt( Right( Left(
                          FCurrentEntry[i], 5 ), 1 ) )] := Right(
                            FCurrentEntry[i],
                          Length(
                          FCurrentEntry[i] ) -
                          Length( 'EXTTx=' ) );
                      //Inc( TrackNum );  //After this, TrackNum is no longer needed!
                      *)
                      { FVC }
                      Track := FCurrentEntry[i][5];
                      Separation := Pos( '=', FCurrentEntry[i] );
                      if Separation = 7 then
                        Track := Track + FCurrentEntry[i][6];
                      TrackNum := StrToInt( Track );
                      FCDInfo.AddTrkInfo[TrackNum] :=
                        FixBackSlashes( FCDInfo.AddTrkInfo[TrackNum] +
                        Right( FCurrentEntry[i], Length( FCurrentEntry[i] ) -
                        Separation ) );
                      { end FVC }
                    end
                    else
                      if Uppercase( Left( FCurrentEntry[i], Length( 'PLAYORDER'
                        )
                        ) ) = 'PLAYORDER' then
                      begin
                        //We've got no use for a playorder!
                      end;
    end;
  end;
end;
{$R+}
{$ENDIF}

procedure TCddb.FormCurrentEntry;
var
  i, j : integer;

  function FixEscapes( Line : string ) : string;
  var
    Location : integer;
  begin
    { changes all #13#10s to "\n"  }
    Location := Pos( #13#10, Line );
    while ( Location > 0 ) do
    begin
      Line := Left( Line, Location - 1 ) + '\n' + Right(
        Line, Length( Line ) - Location - 1 );
      Location := Pos( #13#10, Line );
    end;
    { changes all #13s to "\n"  }
    Location := Pos( #13, Line );
    while ( Location > 0 ) do
    begin
      Line := Left( Line, Location - 1 ) + '\n' + Right(
        Line, Length( Line ) - Location );
      Location := Pos( #13, Line );
    end;
    { changes all #10s to "\n"  }
    Location := Pos( #10, Line );
    while ( Location > 0 ) do
    begin
      Line := Left( Line, Location - 1 ) + '\n' + Right(
        Line, Length( Line ) - Location );
      Location := Pos( #10, Line );
    end;
    { changes all #9s to "\t"  }
    Location := Pos( #9, Line );
    while ( Location > 0 ) do
    begin
      Line := Left( Line, Location - 1 ) + '\t' + Right(
        Line, Length( Line ) - Location );
      Location := Pos( #9, Line );
    end;
    Result := Line;
  end;
begin
  for i := 0 to EntryArrayLength - 1 do
  begin
    if FCurrentEntry[i] = '' then
      break;
    FCurrentEntry[i] := '';
  end;

  j := 0;

  FCurrentEntry[j] := '# xmcd';
  Inc( j );
  FCurrentEntry[j] := '#';
  Inc( j );
  FCurrentEntry[j] := '# Track frame offsets:';
  Inc( j );
  for i := 0 to FCDInfo.CDToc.TracksOnCD do
  begin
    if i < FCDInfo.CDToc.TracksOnCD then
      with FCDInfo.CDToc.Tracks[i] do
        FCurrentEntry[j + i] := Format( '#%s%s', [#9, IntToStr( ( M * 60 + S ) *
            75 +
            F )] )
    else
      with FCDInfo.CDToc.LeadOut do
        FCurrentEntry[j + i] := Format( '#%s%s', [#9, IntToStr( ( M * 60 + S ) *
            75 +
            F )] );
  end;
  Inc( j, FCDInfo.CDToc.TracksOnCD );
  FCurrentEntry[j] := '#';
  Inc( j );
  FCurrentEntry[j] := '# Disc length: ' + IntToStr( FCDInfo.CDToc.LeadOut.M * 60
    + FCDInfo.CDToc.LeadOut.S ) + ' seconds';
  Inc( j );
  FCurrentEntry[j] := '#';
  Inc( j );
  FCurrentEntry[j] := '# Revision: ' + IntToStr( FCDInfo.Revision );
  Inc( j );
  //FCurrentEntry[j] := '# Submitted via: Ari''s freedb component v0.1.70 Release';
  FCurrentEntry[j] := '# Submitted via: ' + FClientName + ' ' + FClientVersion +
    ' ' + FClientComments;
  Inc( j );
  FCurrentEntry[j] := '#';
  Inc( j );
  FCurrentEntry[j] := 'DISCID=' + FCDInfo.DiscID;
  Inc( j );
  FCurrentEntry[j] := 'DTITLE=' + FCDInfo.Artist + ' / ' + FCDInfo.Title;
  Inc( j );
  FCurrentEntry[j] := 'DYEAR=' + FixEscapes( FCDInfo.Year );
  Inc( j );
  FCurrentEntry[j] := 'DGENRE=' + FixEscapes( FCDInfo.Genre );
  Inc( j );
  for i := 0 to FCDInfo.CDToc.TracksOnCD - 1 do
  begin
    FCurrentEntry[j + i] := 'TTITLE' + IntToStr( i ) + '=' + FixEscapes(
      FCDInfo.Tracks[i] );
  end;
  Inc( j, FCDInfo.CDToc.TracksOnCD );
  FCurrentEntry[j] := 'EXTD=' + FCDInfo.AddAlbumInfo;
  Inc( j );
  for i := 0 to FCDInfo.CDToc.TracksOnCD - 1 do
  begin
    FCurrentEntry[j + i] := 'EXTT' + IntToStr( i ) + '=' + FixEscapes(
      FCDInfo.AddTrkInfo[i] );
  end;
  Inc( j, FCDInfo.CDToc.TracksOnCD );
  FCurrentEntry[j] := 'PLAYORDER='; //We have no playorder
  Inc( j );
  FCurrentEntry[j] := '';
end;

function TCDDB.Quit : Integer;
var
  Command : string;
begin
  Result := FAIL;

  if not FState >= CS_CONNECTED then
  begin
    if Assigned( FOnStatusMessage ) then
      OnStatusMessage( Self, 'Not connected' );
    Exit;
  end;

  Command := 'quit';

  Result := FCDDBSocket.SendStr( Command + #13#10 );
  if Result <> FAIL then
  begin
    FState := CS_QUIT;
    if Assigned( FOnStatusMessage ) then
      OnStatusMessage( Self, 'Quitting' );
    if Assigned( FOnStatusMessage ) then
      OnStatusMessage( Self, 'Closing connection' );
    if Assigned( FOnDataExchange ) then
      OnDataExchange( Self, Command + #13#10 );
  end
  else
  begin
    if Assigned( FOnStatusMessage ) then
      OnStatusMessage( Self,
        'CDDB Component Internal Error: TICSSocket.SendStr failed' );
  end;
end;

procedure TCddb.SetNoteToUser( Note : string );
begin
  // In this function we set a proper length for FNoteToUser
  if Length( Note ) > 70 then
  begin
    FNoteToUser := Left( Note, 70 );
  end
  else
  begin
    FNoteToUser := Note;
  end;
end;

{$IFNDEF LINUX}

function TCddb.ChangeActiveDrive( DriveNum : Byte ) : Boolean;
begin
  if not FInternalTOCRetrieve then
  begin
    if Assigned( FOnStatusMessage ) then
      OnStatusMessage( Self, 'No CD-ROM interface detected!' );
    Result := False;
    Exit;
  end;
  Result := False;
  GetCdRomDrives( FCdRoms );

  if ( DriveNum >= 0 ) and ( DriveNum <= FCdRoms.CdRomCount - 1 ) then
  begin

    (* This causes MANY problems!!
    //{ FVC }
    //ZeroMemory( @FCDInfo, SizeOf( FCDInfo ) );
    //{ end FVC }
    *)

    Result := not ReadCDToc( FCdRoms, DriveNum, FCDInfo.CDToc );
    if not Result then
    begin
      if Assigned( FOnStatusMessage ) then
        OnStatusMessage( Self, 'No CD in CD/DVD drive!' );
    end;
    FCDInfo.DiscID := LowerCase( IntToHex( CalcDiscID( FCDInfo.CDToc ), 8 ) );
    FCdRoms.ActiveCdRom := DriveNum;
  end;
end;

function TCddb.ChangeActiveDrive( DriveLetter : Char ) : Boolean;
var
  i : integer;
begin
  if not FInternalTOCRetrieve then
  begin
    if Assigned( FOnStatusMessage ) then
      OnStatusMessage( Self, 'No CD-ROM interface detected!' );
    Result := False;
    Exit;
  end;

  for i := 0 to FCdRoms.CdRomCount - 1 do
  begin
    if Uppercase( FCdRoms.CdRom[i].DriveLetter ) = Uppercase( DriveLetter ) then
      Break;
  end;

  Result := ChangeActiveDrive( i );

end;

function TCddb.RefreshDrives : Boolean;
begin
  Result := ChangeActiveDrive( FCdRoms.ActiveCdRom );
end;

function TCddb.GetActiveDrive : Byte; assembler;
asm  //just trying to learn a bit assembly ;-) Not a great optimization.
  mov al, [eax].TCddb.FCdRoms.ActiveCdRom
end;

function TCddb.GetActiveDriveLetter : Char;
begin
  if not FInternalTOCRetrieve then
  begin
    if Assigned( FOnStatusMessage ) then
      OnStatusMessage( Self, 'No CD-ROM interface detected!' );
    Result := #0;
    Exit;
  end;

  Result := UpperCase( FCdRoms.CdRom[FCdRoms.ActiveCdRom].DriveLetter )[1];

end;

{$ENDIF}

//{$IFNDEF INTERNAL-PARSER}

function TCddb.ParseEntry : integer;
var
  LocalCDDB : TLocalCDDB;
  TempCategory : string;
begin
  TempCategory := FCDInfo.Category; //Parsing loses the category, so we save it
  try
    LocalCDDB := TLocalCDDB.Create( FLocalCDDBDLLPath );
    LocalCDDB.CDDBPath := IncludeTrailingPathDelimiter( FLocalCDDBPath );
  except on ENoDll do
    begin
      if Assigned( FOnStatusMessage ) then
        OnStatusMessage( Self, 'LocalCDDB.dll not found or invalid' );
      //LocalCDDB.Free;
      Result := FAIL;
      Exit;
    end;
  end;
  Result := LocalCDDB.ParseCDDBString( FCDInfo, FCurrentEntry );
  if Result = RD_ERR_CORRUPT then
  begin
    if Assigned( FOnStatusMessage ) then
      OnStatusMessage( Self, 'The entry is corrupt' );
  end;

  RefreshDrives;
  FCDInfo.Category := TempCategory;
  //Parsing loses the category, so we restore it
  LocalCDDB.Free;
end;

function TCddb.FormEntry : integer;
var
  LocalCDDB : TLocalCDDB;
  i : integer;
begin
  try
    LocalCDDB := TLocalCDDB.Create( FLocalCDDBDLLPath );
    LocalCDDB.CDDBPath := IncludeTrailingPathDelimiter( FLocalCDDBPath );
  except on ENoDll do
    begin
      if Assigned( FOnStatusMessage ) then
        OnStatusMessage( Self, 'LocalCDDB.dll not found or invalid' );
      Result := FAIL;
      //LocalCDDB.Free;
      Exit;
    end;
  end;
  for i := 0 to EntryArrayLength - 1 do
  begin
    if FCurrentEntry[i] = '' then
      break;
    FCurrentEntry[i] := '';
  end;
  Result := LocalCDDB.CreateCDDBString( FCDInfo, FCurrentEntry );
  if Result = CS_ERR_OVERFLOW then
  begin
    if Assigned( FOnStatusMessage ) then
      OnStatusMessage( Self, 'The buffer is too small' );
  end;
  LocalCDDB.Free;
end;

function TCddb.SaveInfoToLocalCDDB : integer;
var
  LocalCDDB : TLocalCDDB;
begin
  try
    LocalCDDB := TLocalCDDB.Create( FLocalCDDBDLLPath );
    LocalCDDB.CDDBPath := IncludeTrailingPathDelimiter( FLocalCDDBPath );
  except on ENoDll do
    begin
      if Assigned( FOnStatusMessage ) then
        OnStatusMessage( Self, 'LocalCDDB.dll not found or invalid' );
      Result := FAIL;
      //LocalCDDB.Free;
      Exit;
    end;
  end;
  if FCDInfo.Category = '' then
  begin
    FCDInfo.Category := 'misc';
  end;
  Inc( FCDInfo.Revision ); // We have to increase the revision
  Result := LocalCDDB.WriteCDData( FCDInfo );
  if Result < 0 then
  begin
    case Result of
      WD_ERR_ARG :
        if Assigned( FOnStatusMessage ) then
          OnStatusMessage( Self, 'Invalid arguments' );
      WD_ERR_DIR :
        if Assigned( FOnStatusMessage ) then
          OnStatusMessage( Self, 'Error creating the directory' );
      WD_ERR_FILE_CREATE :
        if Assigned( FOnStatusMessage ) then
          OnStatusMessage( Self, 'Error creating the file' );
      WD_ERR_FILE_WRITE :
        if Assigned( FOnStatusMessage ) then
          OnStatusMessage( Self, 'Error writing to file' );
    end;
  end;
  LocalCDDB.Free;
end;

function TCddb.ReadInfoFromLocalCDDB : integer;
var
  LocalCDDB : TLocalCDDB;
begin
  try
    LocalCDDB := TLocalCDDB.Create( FLocalCDDBDLLPath );
    LocalCDDB.CDDBPath := IncludeTrailingPathDelimiter( FLocalCDDBPath );
  except on ENoDll do
    begin
      if Assigned( FOnStatusMessage ) then
        OnStatusMessage( Self, 'LocalCDDB.dll not found or invalid' );
      Result := FAIL;
      //LocalCDDB.Free;
      Exit;
    end;
  end;
  Result := LocalCDDB.ReadCDData( FCDInfo );
  if Result < 0 then
  begin
    case Result of
      RD_ERR_ARG :
        if Assigned( FOnStatusMessage ) then
          OnStatusMessage( Self, 'Invalid arguments' );
      RD_ERR_FILE :
        if Assigned( FOnStatusMessage ) then

          OnStatusMessage( Self, 'Couldn''t find the file' );
      RD_ERR_READ :
        if Assigned( FOnStatusMessage ) then
          OnStatusMessage( Self, 'Error reading file' );
      RD_ERR_CORRUPT :
        if Assigned( FOnStatusMessage ) then
          OnStatusMessage( Self, 'The file is corrupt' );
    end;
  end;
  LocalCDDB.Free;
  FormEntry;
end;

{$IFNDEF BCB}

function TCddb.FindMatchesFromLocalCDDB : TMatches;
{$ELSE}

function TCddb.FindMatchesFromLocalCDDB( Matches : Integer ) : Integer;
type
  PMatches = ^TMatches;
{$ENDIF}
var
  LocalCDDB : TLocalCDDB;
  RetVal : integer;
begin
  try
    LocalCDDB := TLocalCDDB.Create( FLocalCDDBDLLPath );
    LocalCDDB.CDDBPath := IncludeTrailingPathDelimiter( FLocalCDDBPath );
  except on ENoDll do
    begin
      if Assigned( FOnStatusMessage ) then
        OnStatusMessage( Self, 'LocalCDDB.dll not found or invalid' );
      //LocalCDDB.Free;
      Exit;
    end;
  end;

{$IFNDEF BCB}
  RetVal := LocalCDDB.FindMatches( FCDInfo, Result );
{$ELSE}
  ZeroMemory( PMatches( Matches ), SizeOf( TMatches ) );
  RetVal := LocalCDDB.FindMatches( FCDInfo, PMatches( Matches )^ );
{$ENDIF}
  if RetVal = FM_ERR_MATCH then
  begin
    if Assigned( FOnStatusMessage ) then
      OnStatusMessage( Self, 'Match(es) found from local CD database' );
  end
  else
    if RetVal = FM_ERR_NOMATCH then
    begin
      if Assigned( FOnStatusMessage ) then
        OnStatusMessage( Self, 'No match(es) found from local CD database' );
    end;
{$IFDEF BCB}
  Result := Matches; //Just for your convenience.
{$ENDIF}
  LocalCDDB.Free;
end;
//{$ENDIF}

function TCddb.GetEntryLine( Index : integer ) : string;
begin
  Result := FCurrentEntry[Index];
end;

procedure TCddb.SetEntryLine( Index : integer; Line : string );
begin
  FCurrentEntry[Index] := Line;
end;

function TCddb.GetServerByIndex( Index : integer ) :
{$IFNDEF BCB}TServer{$ELSE}PServer{$ENDIF};
begin
{$IFNDEF BCB}
  Result := FServers[Index];
{$ELSE}
  Result := @( FServers[Index] );
{$ENDIF}
end;

procedure TCddb.SetServerByIndex( Index : integer; Server :
{$IFNDEF BCB}TServer{$ELSE}PServer{$ENDIF} );
begin
{$IFNDEF BCB}
  FServers[Index] := Server;
{$ELSE}
  FServers[Index] := Server^;
{$ENDIF}
end;

function TCddb.GetCDInfo : PCDInfo;
begin
  Result := @FCDInfo;
end;

procedure TCddb.SetCDInfo( Info : PCDInfo );
begin
  FCDInfo := Info^;
end;

procedure Register;
begin
  RegisterComponents( 'Nanojiffy', [TCddb] );
end;

{$IFDEF HTTP-SUPPORT}

function TCDDB.http_query : Integer;
var
  Command : string;
begin
  Result := FAIL;
  if FServerType <> HTTP then
  begin
    if Assigned( FOnStatusMessage ) then
      OnStatusMessage( Self, 'Selected server not an HTTP server' );
    exit;
  end;

  FStreamIn.Clear;
  FStreamIn.Seek( 0, soFromBeginning );

  FHttpCli.RcvdStream := FStreamIn;
  Command := Format( 'http://%s%s?cmd=%s&hello=%s+%s+%s&proto=5',
    [FServerAddr, FServerAdditionalAddr, Encode( GenerateQueryString(
      FCDInfo.CDToc ) ),
    Encode( BreakEmlAddr( FUserEmailAddr ) ), Encode( FClientname ),
      Encode( FClientVersion )]
      );
  FHttpCli.URL := Command;

  try
    if Assigned( FOnStatusMessage ) then
      OnStatusMessage( Self, 'Querying CD' );
    if Assigned( FOnDataExchange ) then
      OnDataExchange( Self, Command + #13#10 );

    FHttpCli.GetAsync;

    Result := SUCCESS;
    FState := CS_QUERYED;
  except
    //Exit;
    Result := FAIL;
    FState := CS_HTTPERROR;
    if Assigned( FOnStatusMessage ) then
      OnStatusMessage( Self,
        'CDDB Component Internal Error: THttpCli.GetAsync failed because of error "' +
        FHttpCli.ReasonPhrase + '"' );
    Exit;
  end;
end;

function TCDDB.http_read : Integer;
var
  Command : string;
begin
  Result := FAIL;

  if FState = CS_NOMATCH then
  begin
    if Assigned( FOnStatusMessage ) then
      OnStatusMessage( Self,
        'Can''t perform a CDDB READ without a successful CDDB QUERY!' );
    Result := FAIL;
    exit;
  end;

  if FServerType <> HTTP then
  begin
    if Assigned( FOnStatusMessage ) then
      OnStatusMessage( Self, 'Selected server not an HTTP server' );
    exit;
  end;

  FStreamIn.Clear;
  FStreamIn.Seek( 0, soFromBeginning );

  FHttpCli.RcvdStream := FStreamIn;

  Command :=
    Format( 'http://%s%s?cmd=cddb+read+%s+%s&hello=%s+%s+%s&proto=5',
    [FServerAddr, FServerAdditionalAddr, Trim( FCDInfo.Category ), Trim(
      FCDInfo.DiscID ),
    Encode( BreakEmlAddr( FUserEmailAddr ) ), Encode( FClientName ),
      Encode( FClientVersion )]
      );
  FHttpCli.URL := Command;
  try
    if Assigned( FOnStatusMessage ) then
      OnStatusMessage( Self, 'Reading CD info' );
    if Assigned( FOnDataExchange ) then
      OnDataExchange( Self, Command + #13#10 );

    FHttpCli.GetAsync;

    Result := SUCCESS;
    FState := CS_SAIDREAD;

  except
    //Exit;
    Result := FAIL;
    FState := CS_HTTPERROR;
    if Assigned( FOnStatusMessage ) then
      OnStatusMessage( Self,
        'CDDB Component Internal Error: THttpCli.GetAsync failed because of error "' +
        FHttpCli.ReasonPhrase + '"' );
    Exit;
  end;
end;

procedure TCddb.HttpOnCommand( Sender : TObject; var S : string );
var
  Lines, SubmitString : string;
begin
  // In this function additional header lines should be written.
  // Just detect one of the header lines and add text at the end of this   }
  // line. Use #13#10 to form a new line                                   }
{
Category: valid_freedb_category
Discid: cd_discid
User-Email: username@domain
Submit-Mode: test_or_submit
Content-Length: freedb_entry_length
Charset: character_set_of_freedb_entry (optional)
X-Cddbd-Note: message_for_user         (optional)
}

  if FState <> CS_HTTPSUBMIT then
    exit;

  case FSubmissionType of
    TEST :
      SubmitString := 'test';
    SUBMIT :
      SubmitString := 'submit';
  end;

  Lines := Format(
    '%sCategory: %s%sDiscid: %8.8x%sUser-Email: %s%sSubmit-Mode: %s%sX-Cddbd-Note: %s',
    [#13#10, Trim( FCDInfo.Category ), #13#10, CalcDiscID( FCDInfo.CDToc ),
    #13#10, FUserEmailAddr, #13#10, SubmitString, #13#10, FNoteToUser] );

  if Left( S, 15 ) = 'Content-Length:' then
  begin
    S := S + Lines;
  end;

end;

procedure TCddb.HttpOnRequestDone( Sender : TObject; RqType : THttpRequest; Error
  : Word );
var
  i : integer;
  Lines : TStringList;
begin
  if Error = 0 then
    case FState of
      CS_QUERYED :
        begin
          Lines := TStringList.Create;
          with Lines do
          begin
            // ZeroMemory causes problems, I've just got to trust that this'll do without.
            LoadStringListFromMemoryStream( Lines, FStreamIn );
            for i := 0 to Count - 1 do
            begin
              if Assigned( FOnDataExchange ) then
                OnDataExchange( Self, Strings[i] );
              ParseQuery( Strings[i] );
            end;
            Free;
          end;
        end;
      CS_HTTPSUBMIT :
        begin
          Lines := TStringList.Create;
          with Lines do
          begin
            // ZeroMemory causes problems, I've just got to trust that this'll do without.
            LoadStringListFromMemoryStream( Lines, FStreamIn );
            for i := 0 to Count - 1 do
            begin
              if Assigned( FOnDataExchange ) then
                OnDataExchange( Self, Strings[i] );
              ParseSubmit( Strings[i] );
            end;
            Free;
          end;
        end;
      CS_SAIDREAD :
        begin
          Lines := TStringList.Create;
          with Lines do
          begin
            // ZeroMemory causes problems, I've just got to trust that this'll do without.
            LoadStringListFromMemoryStream( Lines, FStreamIn );
            for i := 0 to Count - 1 do
            begin
              if Assigned( FOnDataExchange ) then
                OnDataExchange( Self, Strings[i] );
              ParseRead( Strings[i] );
            end;
            Free;
          end;
{$IFDEF INTERNAL-PARSER}
          ParseCurrentEntry;
{$ELSE}
          ParseEntry;
{$ENDIF}
        end;
      CS_SITESASKED :
        begin
          Lines := TStringList.Create;
          with Lines do
          begin
            // ZeroMemory causes problems, I've just got to trust that this'll do without.
            LoadStringListFromMemoryStream( Lines, FStreamIn );
            for i := 0 to Count - 1 do
            begin
              if Assigned( FOnDataExchange ) then
                OnDataExchange( Self, Strings[i] );
              ParseSites( Strings[i] );
            end;
            Free;
          end;
        end;
    end
  else
  begin
    if FState <> CS_HTTPSUBMIT then
    begin
      FState := CS_HTTPERROR;
      if Assigned( FOnStatusMessage ) then
        OnStatusMessage( Self,
          'CDDB Component Internal Error: THttpCli.GetAsync failed because of error "' +
          FHttpCli.ReasonPhrase + '"' );
    end
    else
    begin
      FState := CS_HTTPERROR;
      if Assigned( FOnStatusMessage ) then
        OnStatusMessage( Self,
          'CDDB Component Internal Error: THttpCli.PostAsync failed because of error "' +
          FHttpCli.ReasonPhrase + '"' );
    end;
  end;
end;

function TCddb.http_submit : integer;
var
  Buf : PChar; //string;
  i : integer;
begin

  Result := FAIL;
  if FServerType <> HTTP then
  begin
    if Assigned( FOnStatusMessage ) then
      OnStatusMessage( Self, 'Selected server not an HTTP server' );
    exit;
  end;

  FStreamIn.Clear;
  FStreamIn.Seek( 0, soFromBeginning );
  FStreamOut.Clear;
  FStreamOut.Seek( 0, soFromBeginning );

  Buf := '';
  for i := 0 to EntryArrayLength - 1 do
  begin
    if ( FCurrentEntry[i] = '' ) or ( Trim( FCurrentEntry[i] ) = '' ) then
    begin
      break;
    end;
    //    Buf := Buf + FCurrentEntry[i] + #13#10;
    Buf := PChar( Buf + FCurrentEntry[i] + #13#10 );
  end;

  //FStreamOut.Write( Buf[1], Length( Buf ) );
  FStreamOut.Write( Buf^, Length( Buf ) );
  FStreamOut.Seek( 0, soFromBeginning );

  FHTTPCli.SendStream := FStreamOut;
  FHTTPCli.RcvdStream := FStreamIn;

  FHttpCli.URL := 'http://' + FServerAddr + '/~cddb/submit.cgi';

  try
    case FSubmissionType of
      TEST :
        if Assigned( FOnStatusMessage ) then
          OnStatusMessage( Self, 'Test-submitting CD info' );
      SUBMIT :
        if Assigned( FOnStatusMessage ) then
          OnStatusMessage( Self, 'Submitting CD info' );
    end;
    if Assigned( FOnDataExchange ) then
      OnDataExchange( Self, FHttpCli.URL + #13#10 );

    FState := CS_HTTPSUBMIT;

    FHttpCli.PostAsync;

    Result := SUCCESS;

  except
    //Exit;
    Result := FAIL;
    FState := CS_HTTPERROR;
    if Assigned( FOnStatusMessage ) then
      OnStatusMessage( Self,
        'CDDB Component Internal Error: THttpCli.PostAsync failed because of error "' +
        FHttpCli.ReasonPhrase + '"' );
    Exit;
  end;
end;

procedure TCDDB.ParseSubmit( Line : string );
var
  Code : integer;
begin
  Code := strtoint( Left( Line, 3 ) );

  case Code of
    200 :
      begin
        { FVC }
        if Assigned( FOnStatusMessage ) then
          { end FVC }
          OnStatusMessage( Self, 'OK, submission has been sent.' );
      end;
    500 :
      begin
        { FVC }
        if Assigned( FOnStatusMessage ) then
          { end FVC }
          OnStatusMessage( Self, 'Missing required header information.' );
      end;
    501 :
      begin
        { FVC }
        if Assigned( FOnStatusMessage ) then
          { end FVC }
          OnStatusMessage( Self, 'Invalid header information.' );
      end;
  end;
end;

function TCddb.http_sites : integer;
var
  Command : string;
begin
  Result := FAIL;

  if FServerType <> HTTP then
  begin
    if Assigned( FOnStatusMessage ) then
      OnStatusMessage( Self, 'Selected server not an HTTP server' );
    exit;
  end;

  FStreamIn.Clear;
  FStreamIn.Seek( 0, soFromBeginning );
  FHttpCli.RcvdStream := FStreamIn;

  Command :=
    Format( 'http://%s%s?cmd=sites&hello=%s+%s+%s&proto=5',
    [FServerAddr, FServerAdditionalAddr,
    Encode( BreakEmlAddr( FUserEmailAddr ) ), Encode( FClientname ), Encode(
      FClientVersion )] );

  FHttpCli.URL := Command;

  try
    if Assigned( FOnStatusMessage ) then
      OnStatusMessage( Self, 'Getting sites' );
    if Assigned( FOnDataExchange ) then
      OnDataExchange( Self, Command + #13#10 );

    FHttpCli.GetAsync;

    Result := SUCCESS;
    FState := CS_SITESASKED;
  except
    //Exit;
    Result := FAIL;
    FState := CS_HTTPERROR;
    if Assigned( FOnStatusMessage ) then
      OnStatusMessage( Self,
        'CDDB Component Internal Error: THttpCli.GetAsync failed because of error "' +
        FHttpCli.ReasonPhrase + '"' );
    Exit;
  end;
end;
{ FVC }

procedure TCddb.http_SetProxyAddress;
begin
  FHttpCLI.Proxy := TheAddress;
end;

procedure TCddb.http_SetProxyPort;
begin
  FHttpCLI.ProxyPort := ThePort;
end;

function TCddb.http_GetProxyAddress;
begin
  result := FHttpCLI.Proxy;
end;

function TCddb.http_GetProxyPort;
begin
  result := FHttpCLI.ProxyPort;
end;
{ end FVC }
{$ENDIF}

function TCddb.smtp_submit : Integer;
var
  i : integer;
begin
  Result := FAIL;

  with FSMTPCli do
  begin

    case FSubmissionType of
      TEST :
        begin
          if Assigned( FOnStatusMessage ) then
            OnStatusMessage( Self, 'Test-submitting CD info' );
          FSubmitEmailAddr := 'test-submit@freedb.org';
        end;
      SUBMIT :
        begin
          if Assigned( FOnStatusMessage ) then
            OnStatusMessage( Self, 'Submitting CD info' );
          FSubmitEmailAddr := 'freedb-submit@freedb.org';
        end;
    end;

    Host := FMailServerAddr;
    Port := FMailServerPort;

    HdrFrom := FUserEmailAddr;
    HdrTo := FSubmitEmailAddr;
    FromName := HdrFrom;
    RcptName.Clear;
    RcptName.Add( HdrTo );
    HdrSender := HdrFrom;
    CharSet := 'iso-8859-1';
    ContentType := smtpPlainText;

    MailMessage.Clear;
    for i := 0 to EntryArrayLength - 1 do
    begin
      if FCurrentEntry[i] <> '' then
        MailMessage.Add( FCurrentEntry[i] )
    end;

    HdrSubject := Format( 'cddb %s %s', [FCDInfo.Category, FCDInfo.DiscID] );
    FState := CS_SMTPSUBMIT;
    Connect;
  end;

end;

procedure TCddb.SmtpOnRequestDone( Sender : TObject; RqType : TSmtpRequest; Error
  : Word );
var
  ErrMsg, ErrWord : string;
begin
  //  OnDataExchange( Self, FSmtpCli.LastResponse );
  with FSmtpCli do

  begin
    if Error = 0 then
    begin
      if RqType = smtpConnect then
        Helo;
      if RqType = smtpHelo then
        Mail;
      if RqType = smtpMail then
        Quit;
      if RqType = smtpQuit then
        if Assigned( FOnStatusMessage ) then
          OnStatusMessage( Self,
            'OK, submission has been sent.' );
    end
    else
    begin
      FState := CS_SMTPERROR;
      if RqType = smtpConnect then
        ErrWord := 'Connect';
      if RqType = smtpHelo then
        ErrWord := 'Helo';
      if RqType = smtpMail then
        ErrWord := 'Mail';
      if RqType = smtpQuit then
        ErrWord := 'Quit';
      Errmsg := Format(
        'CDDB Component Internal Error: TSmtpCli.%s failed because of error "%s"', //. Error code %d."',
        [ErrWord, FSmtpCli.ErrorMessage] ); //, Error] );
      if Assigned( FOnStatusMessage ) then
        OnStatusMessage( Self, ErrMsg );
    end;
  end;
end;

procedure TCddb.SmtpOnDisplay( Sender : TObject; Msg : string );
begin
  if Assigned( FOnDataExchange ) then
    OnDataExchange( Self, Msg );
end;

procedure TCddb.SmtpOnHeaderLine( Sender : TObject; Msg : PChar; Size : Integer
  );
var
  SNote : string;
  Note : PChar;
begin
  SNote := #13#10 + 'X-Cddbd-Note: ' + FNoteToUser;
  Note := PChar( SNote );

  if StrLIComp( Msg, 'From:', 5 ) = 0 then
  begin
    //Msg := PChar( string(Msg) + Note );
    StrCat( Msg, Note );
  end;
end;

end.

